Summary:       A PKCS
Name:          openssl-pkcs11
Version:       0.4.12
Release:       6%{?dist}
License:       LGPLv2+ and BSD
URL:           https://github.com/OpenSC/libp11
Source0:       https://github.com/OpenSC/libp11/releases/download/libp11-%{version}/libp11-%{version}.tar.gz

Patch0001:     0001-Deffer-initializing-crypto-routines-in-PKCS11-engine.patch
Patch3000:     openssl-pkcs11-0.4.10-set-rsa-fips-method-flag.patch

BuildRequires: make autoconf automake libtool
BuildRequires: openssl-devel openssl >= 3.0.0
BuildRequires: pkgconfig pkgconfig(p11-kit-1)
BuildRequires: softhsm opensc procps-ng 

Requires:      p11-kit-trust  openssl-libs >= 3.0.0

Provides:      libp11 = %{version}-%{release}
Provides:      engine_pkcs11 = %{version}-%{release}

%description -n openssl-pkcs11
openssl-pkcs11 is an abstract API to perform operations on cryptographic 
objects such as private keys, without requiring access to the objects themselves, 
it provides a logical separation of the keys from the operations. The openssl-pkcs11 
API is mainly used to access objects in smart cards and Hardware or Software Security Modules (HSMs).

%package -n libp11-devel
Summary:       Files for developing with libp11
Requires:      openssl-pkcs11 = %{version}-%{release}

%description -n libp11-devel
The libp11-devel package contains libraries and header files for
developing applications that use libp11.

%prep
%autosetup -p1 -n libp11-%{version}

%build
autoreconf -fvi
%configure --disable-static --with-enginesdir=%{_libdir}/engines-3
%make_build

%install
mkdir -p %{buildroot}%{_libdir}/engines-3
%make_install

rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/engines-3/*.la
rm -rf %{buildroot}%{_docdir}/libp11/

%check
%make_build check || (cat tests/*.log; exit 1)

%files
%license COPYING
%doc NEWS
%{_libdir}/libp11.so.*
%{_libdir}/engines-3/*.so

%files -n libp11-devel
%doc examples 
%{_libdir}/libp11.so
%{_libdir}/pkgconfig/libp11.pc
%{_includedir}/*.h

%changelog
* Tue Feb 20 2024 Feng Weiyao <wynnfeng@tencent.com> - 0.4.12-6
- set check exit 1 when test fails as openssl-3.0.12 temporarily fix this bug

* Thu Feb 01 2024 Feng Weiyao <wynnfeng@tencent.com> - 0.4.12-5
- set check exit 0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.12-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.12-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.12-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Aug 3 2022 Feng Weiyao <wynnfeng@tencent.com> - 0.4.12-1
- package init.
 